;==========================================
;created with ==>MASM IDE version 5.3
;written by "OSSAMA.H"
;email==>ossama_dev@hotmail.com
;==========================================

.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib

include macros.asm
include icon_example.inc

.data
	hInstance		dd	?

	hIcon			dd	?
	hImageList		dd	NULL

	szItemText		db	"item with icon",0

.code
start:
	;init the common controls library
	invoke InitCommonControls

	invoke GetModuleHandle,NULL
	mov hInstance,eax
	invoke DialogBoxParam,hInstance,1000,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;===================================================================

DlgProc proc hdlg:dword,message:dword,wParam:dword,lParam:dword
	local tbb:TBBUTTON
	local lvi:LVITEM

	.if message==WM_INITDIALOG
;----------------------------------------------------------------------------------------------
		;load icon
		invoke LoadImage,hInstance,sz("icon"),IMAGE_ICON,0,0,0
		.if eax==NULL
			invoke MessageBox,hdlg,sz("error in loading icon"),NULL,MB_OK
			jmp @F
		.endif
		mov hIcon,eax
;----------------------------------------------------------------------------------------------
		;set icon to button
		invoke SendDlgItemMessage,hdlg,BTN_OK,BM_SETIMAGE,IMAGE_ICON,hIcon
;----------------------------------------------------------------------------------------------
		;add button to toolbar

		invoke SendDlgItemMessage,hdlg,TOOLBAR,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0

		mov cx,50	;height of buttons
		shl ecx,16
		mov cx,50	;width of buttons
		invoke SendDlgItemMessage,hdlg,TOOLBAR,TB_SETBUTTONSIZE,0,ecx

		invoke ImageList_Create,48,48,ILC_COLOR32,0,0
		.if eax==NULL
			invoke MessageBox,hdlg,sz("error in image list"),NULL,MB_OK
			jmp @F
		.endif
		mov hImageList,eax

		invoke ImageList_AddIcon,hImageList,hIcon

		invoke SendDlgItemMessage,hdlg,TOOLBAR,TB_SETIMAGELIST,0,hImageList

		mov tbb.fsState,TBSTATE_ENABLED
		mov tbb.dwData,0
		mov tbb.iString,0
		mov tbb.fsStyle,TBSTYLE_BUTTON
		mov tbb.idCommand,BTN_OK
		mov tbb.iBitmap,0	;this is the zero based index of the only icon we have in the image list
		invoke SendDlgItemMessage,hdlg,TOOLBAR,TB_ADDBUTTONS,1,addr tbb
		invoke SendDlgItemMessage,hdlg,TOOLBAR,TB_AUTOSIZE,0,0

;----------------------------------------------------------------------------------------------
		;add items to listview

		invoke SendDlgItemMessage,hdlg,LISTVIEW,LVM_SETIMAGELIST,LVSIL_NORMAL,hImageList

		mov lvi.imask,LVIF_TEXT+LVIF_IMAGE
		mov lvi.iItem,0
		mov lvi.iSubItem,0
		mov lvi.pszText,offset szItemText
		mov lvi.cchTextMax,sizeof szItemText
		mov lvi.iImage,0
		invoke SendDlgItemMessage,hdlg,LISTVIEW,LVM_INSERTITEM,0,addr lvi
	.elseif message==WM_COMMAND
		.if lParam!=0
			mov eax,wParam
			mov edx,eax
			shr edx,16
			.if dx==BN_CLICKED
				.if ax==BTN_OK
					invoke SendMessage,hdlg,WM_CLOSE,0,0
				.endif
			.endif
		.endif
	.elseif message==WM_CLOSE
@@:
		.if hImageList!=NULL
			invoke ImageList_Destroy,hImageList
		.endif
		invoke EndDialog,hdlg,0
	.else
		return FALSE
	.endif
	return TRUE
DlgProc endp

end start